//
// FPGA PACMAN "THROUGH" video encoder module
//
// Version : beta2
//
// Copyright(c) 2003 Tatsuyuki Satoh , All rights reserved
//
// Important !
//
// This software is freeware for non-commercial use. 
// This software is provided "AS IS", without warranty of any kind.
// You can use this under your own risk. 
//
// 2003. 2.17 created
//

module venc_rgb8(
  pclk,dclk,vclk,rgb8_in,hs_in,vs_in,
  r_out,r_tri,g_out,g_tri,b_out,b_tri,
  hs_out,hs_tri,vs_out,vs_tri
);
// input signals
input pclk;             // 6.144MHz  input pixel clock
input dclk;             // 12.288Mhz output pixel clock
input vclk;		// VIDEO pixel clock (not used)
input [7:0] rgb8_in;    // RGB   input
input hs_in;            // HSYNC input (16KHz)
input vs_in;            // VSYNC input (60Hz)

// output signals
output [4:0] r_out,g_out,b_out; // R,G,B output level
output [4:0] r_tri,g_tri,b_tri; // R,G,B tristate control
output hs_out;          // HSYNC output
output hs_tri;          // HSYNC tristate control
output vs_out;          // VSYNC output
output vs_tri;          // VSYNC tristate control

//---------------------------------------------------------------------------
// output
//---------------------------------------------------------------------------

assign r_tri = { 5'b00011 };
assign r_out = { rgb8_in[7:5],2'b00 };  // 470ohm,1Kohm,2Kohm,open,open
assign g_tri = { 5'b00011 };
assign g_out = { rgb8_in[4:2],2'b00 };  // 470ohm,1Kohm,2Kohm,open,open
assign b_tri = { 5'b00111 };
assign b_out = { rgb8_in[1:0],3'b000 }; // 470ohm,1Kohm,open,open,open

// converted SYNC signal
assign vs_tri = 1'b0;
assign vs_out = ~vs_in;
assign hs_tri = 1'b0;
assign hs_out = ~hs_in;

endmodule
