//
// FPGA PACMAN internal ROM preload circuit
//
// Version : 0.92
//
// Copyright(c) 2004 Tatsuyuki Satoh , All rights reserved
//
// Important !
//
// This software is freeware for non-commercial use. 
// This software is provided "AS IS", without warranty of any kind.
// You can use this under your own risk. 
//
// 2004. 9.16 created
//

module pac_prom(
  clk3x,phase3x,
// Configration ROM
  CFR_EN,CFR_DI,
  CFR_CLK_I,CFR_CLK_O,CFR_CLK_T,
// memory interface
  CFG_EN,CFG_A,CFG_DO,
  CFG_DT,CFG_OE,CFG_WE
);

input clk3x;
input [2:0] phase3x;

// Configration ROM
output CFR_EN;
input CFR_DI;
input CFR_CLK_I;
output CFR_CLK_O;
output CFR_CLK_T;

// memory interface
output CFG_EN;
output [15:0] CFG_A;
output [7:0] CFG_DO;

output CFG_DT; // external tristate controll
output CFG_OE; // external OE
output CFG_WE; // external WE

// redirect extROM 4eff -> 4c00 to internal ROM
reg [9:0] cfg_a_r = 10'h2ff;
reg we_r = 1'b0;
wire cfg_mode = (cfg_a_r!=10'h3ff);

always @(posedge clk3x)
begin
  if(cfg_mode)
  begin
    // 150ns cycle
    if(phase3x[2])
      cfg_a_r <= cfg_a_r - 1;
  end
end

assign CFG_EN = cfg_mode;
assign CFG_A  = {6'b010011,cfg_a_r};
assign CFG_DO = 8'h00;
assign CFG_DT = 1'b1;
assign CFG_OE = 1'b1;
assign CFG_WE = 1'b0;

// don't use configration ROM
assign CFR_EN    = 1'b0;
assign CFR_CLK_O = 1'b0;
assign CFR_CLK_T = 1'b1;

endmodule
