/////////////////////////////////////////////////////////////////////////////
//
// pacman clock generator
//
// Version : 0.92
//
// Copyright(c) 2004 Tatsuyuki Satoh , All rights reserved
//
// Important !
//
// This software is freeware for non-commercial use. 
// This software is provided "AS IS", without warranty of any kind.
// You can use this under your own risk. 
//
// Issue:
//
// Histry:
//   2004. 7.21 1st Release
//
/////////////////////////////////////////////////////////////////////////////

module pac_clk(CLKIN,PHASE3X,CLK_2_3,CLK_1_6);

input  CLKIN;       // 18.432MHz duty 50% base clock
output [2:0] PHASE3X; // clock enable 3turn raise of CLKIN
output CLK_2_3;     // 2/3 divide clock
output CLK_1_6;

//CLKIN    10101010101010101010
//CLK3P[0] 11000011000011000011
//CLK3P[1] 00110000110000110000
//CLK3P[2] 00001100001100001100
//c3n_1    00011000011000011000
//
//CLK2_3   11011011011011011011
//PCLK1_6  11100011100011100011
//NCLK1_6  00011100011100011100

// 3x raise clk enable
reg [2:0] c3p = 3'b000;
reg c3n_1;
always @(posedge CLKIN)
begin
  c3p[0]   <= (c3p[1:0]==2'b00);
  c3p[2:1] <= c3p[1:0];
end
// 3x fall clk enable
always @(negedge CLKIN) c3n_1 <= c3p[1];

assign PHASE3X = c3p;

// 2/3 clock duty 66%
assign CLK_2_3 = c3p[0] | c3n_1;

// 1/3 clock duty 50%
reg c16;
always @(posedge CLK_2_3)
begin
  c16 <= ~c3p[1];
end
assign CLK_1_6   = c16;

endmodule
