//
// FPGA PACMAN I/O interface
//
// Version : 0.92
//
// Copyright(c) 2002,2004 Tatsuyuki Satoh , All rights reserved
//
// Important !
//
// This software is freeware for non-commercial use. 
// This software is provided "AS IS", without warranty of any kind.
// You can use this under your own risk. 
//
// 2004. 9.17 DSW value changes partameter
//

module pac_inp(
// inputs
	LEFT1,
	RIGHT1,
	UP1,
	DOWN1,
	LEFT2,
	RIGHT2,
	UP2,
	DOWN2,
	START1,
	START2,
	COIN1,
	COIN2,
	CREDIT,
	TEST,
	TABLE,
//enables
	IN0_EN,
	IN1_EN,
	DSW1_EN,
	DSW2_EN,
// output
	DO
);

parameter DSW1 = 8'b00000000;
parameter DSW2 = 8'b00000000;

input IN0_EN;
input IN1_EN;
input DSW1_EN;
input DSW2_EN;
input LEFT1,RIGHT1,UP1,DOWN1;
input LEFT2,RIGHT2,UP2,DOWN2;
input START1,START2,COIN1,COIN2;
input CREDIT,TEST,TABLE;
output [7:0] DO;

wire [7:0] in0do,in1do,ds1do,ds2do;

//IN0
wire DSW16 = 1'b1;

assign DO = IN0_EN ? { CREDIT,COIN2,COIN1,DSW16,DOWN1,RIGHT1,LEFT1,UP1 }  :
            IN1_EN ? { TABLE ,START2,START1,TEST,DOWN2,RIGHT2,LEFT2,UP2 } :
            DSW1_EN ? DSW1 :
            DSW2_EN ? DSW2 :
            8'h00;

endmodule
