//
// FPGA PACMAN IRQ / vector handler
//
// Version : 0.92
//
// Copyright(c) 2002-2004 Tatsuyuki Satoh , All rights reserved
//
// Important !
//
// This software is freeware for non-commercial use. 
// This software is provided "AS IS", without warranty of any kind.
// You can use this under your own risk. 
//
// 2003. 2. 6 beta2 bugfix IRQ vector size
//

module pac_irq(n_M1,n_IORQ,n_WR,IRQEN,IRQTRG,DI,n_IRQ,DO,DE);

input n_M1;
input n_IORQ;
input n_WR;
input IRQEN;
input IRQTRG;
input [7:0] DI;
output n_IRQ;
output [7:0] DO;
output DE;

wire iocycle_n = n_IORQ | ~n_M1;
wire spcycle_n = n_IORQ |  n_M1;

//
// I/O write -> set vector
//
reg [7:0] vector_latch;
always @(posedge iocycle_n) vector_latch <= DI;

//
// special M1 cycle  = vector out
//
assign DE = ~spcycle_n;
assign DO = DE ? vector_latch : 8'h00;

//
// IRQ signal
//
reg irq_latch;
always @(posedge IRQTRG or negedge IRQEN)
begin
	if(IRQEN==0) //enable fall
		irq_latch <= 1'b1; //clear
	else // trigger fall
		irq_latch <= 1'b0; //enable
end
assign n_IRQ = irq_latch;

endmodule
